package com.adamrocker.android.hellondk;

import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.TextView;

public class HelloNdkActivity extends Activity {
    static {
        System.loadLibrary("hello-ndk");//共有ライブラリのロード
    }
    
    private OnClickListener mClickListener = new OnClickListener() {
        @Override
        public void onClick(View v) {
            String str = null;
            switch (v.getId()) {
            case R.id.java_btn:
                str = getStringJava();//Javaから文字を取得する
                setText(str);
                break;
            case R.id.native_btn:
                str = getStringNative();//Nativeから文字を取得する
                setText(str);
                break;
            }
        }
    };
    
    public native String getStringNative();//Nativeメソッド
    
    private String getStringJava() {
        return "Hello, World! from Java!";
    }

    private void setText(String str) {
        TextView text = (TextView)findViewById(R.id.text_tv);
        text.setText(str);
    }
    
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        View btn = findViewById(R.id.java_btn);
        btn.setOnClickListener(mClickListener);
        btn = findViewById(R.id.native_btn);
        btn.setOnClickListener(mClickListener);
    }
}
